#!/usr/bin/tclsh

puts "
Description: ParSA with the MINLA problem
Hostname: [exec hostname]
Date: [exec date]
" 

### parsa is awful!
### This script can be used to call it in a more or less safely way.


set reps 1

### This function returns a skeleton for the SA.cfg file.

proc Configuration {} {
	return {
{
	SA_Solver SA_SeqSolver
	{
		SA_Solver
		{
			datafilename		XXXXX
			outputfilename		YYYYY/output
	       	solutionfilename	YYYYY/solution
			overwritesolution	always
			writefunction		path
			verbose				on
			verboselevel		10
			StartSolution		Random
		}
		SA_Scheduler  SA_SeqAartsScheduler 
		{
			initialtemperature 10
			SA_Scheduler
			{
				picturedirectory 	pic
				OptType				MIN
				thresholdvalue		0
				initaccratio 		0.5
				verboselevel		10
				timelimit			-1
			}
			delta				1e31
			subchainfactor		1
			epsilon				0.001
			omega				0.9
		}
		algorithm		SeqAlg
	}
}
}
}


proc stat {l} {
	set n [llength $l]
	set l [lsort -real $l]
	set min [lindex $l 0] 
	set max [lindex $l [expr $n-1]]
	set qmin [lindex $l [expr $n/4]] 
	set qmax [lindex $l [expr 3*$n/4]] 
	
	set avg [average $l]	
	
	return [format "%12.2f %12.2f %12.2f %12.2f %12.2f" $min $qmin $avg $qmax $max]	
}


proc average {l} {
	set n [llength $l]
	set s 0.0
	foreach x $l {
		set s [expr $s+$x]
	}
	return [expr $s/$n]	
}


set cwd [pwd]

foreach f $argv {

	if {![file exists $f]} {
		puts stderr "GRAPH $f NOT FOUND"
		continue
	}

	puts "$f:\n"
	set vs {}
	set ts {}
	for {set i 0} {$i < $reps} {incr i} {

		set prefix [exec mktemp -u /tmp/parsa-XXXXXX]
		puts stderr "Using directory $prefix"
		file mkdir $prefix
		set configuration [Configuration]
		regsub -all "XXXXX" $configuration $f configuration
		regsub -all "YYYYY" $configuration $prefix configuration
		exec cat << $configuration > $prefix/SA.cfg
		exec cp minla.x SA_Output.rsc $prefix
	
		cd $prefix		
		set t [clock seconds]
		catch {
#			exec ./minla.x > $prefix/trace.out 2> $prefix/trace.err
			exec ./minla.x > $prefix/trace.out 2> /dev/tty
		}
		set t [expr [clock seconds]-$t]
		set v [lindex [exec cat $prefix/solution.cost] 0]
		lappend vs $v
		lappend ts $t	
		cd $cwd
		puts stderr "value=$v time=$t"
		exec rm -rf $prefix
	}
	puts -nonewline stderr "\r"
	puts [format "%20s %s %12.2f %5i" sa [stat $vs] [average $ts] $reps]
}

