#!./llsh


proc @ {o} {
	return [$o cget -this]
}


proc delete {o} {
	rename $o ""
}


proc stat {l} {
	set n [llength $l]
	set l [lsort -real $l]
	set min [lindex $l 0] 
	set max [lindex $l [expr $n-1]]
	set qmin [lindex $l [expr $n/4]] 
	set qmax [lindex $l [expr 3*$n/4]] 
	
	set avg [average $l]	
	
	return [format "%12.2f %12.2f %12.2f %12.2f %12.2f" $min $qmin $avg $qmax $max]	
}


proc average {l} {
	set n [llength $l]
	set s 0.0
	foreach x $l {
		set s [expr $s+$x]
	}
	return [expr $s/$n]	
}


foreach graph [lsort $argv] {

	puts "$graph:\n"
	Graph G $graph
	Layout L [@ G]

	foreach method {canonical random spectral greedy_nor greedy_rnd greedy_rbs greedy_bfs greedy_dfs metropolis_E metropolis_2 metropolis_3} {

		if {$method=="canonical" || $method=="spectral"} {
			set r 5
		} else {
			set r 200
		}
	
		puts -nonewline stderr [format "%20s" $method]
		set vs {}
		set ts {}
		for {set i 0} {$i < $r} {incr i} {
			L set_random
			set t1 [clock seconds]
			Minla_$method [@ G] [@ L]
			set t2 [clock seconds]
			set t [expr $t2-$t1]
			set v [L la]
			lappend vs $v
			lappend ts $t
			puts -nonewline stderr "."
		}
#		puts -nonewline stderr "\r"
		puts stderr ""
		puts [format "%20s %s %12.2f" $method [stat $vs] [average $ts]]
					
	}
	delete L
	delete G
	
	puts ""
	puts ""
}



